<?php
/**
 * @version        1.0
 * @package        PayAnyWay payment gateway for iJoomla AdAgency
 * @copyright   Copyright (C) 2018, www.payanyway.ru
 * @license        GNU/GPL, see license.txt
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 */

defined('_JEXEC') or die('Restricted access');

class payanyway
{

    function selfile()
    {
        return "payanyway_payment.php";
    }

    function type()
    {
        return "payment";
    }

    function getBEData ($plugin_conf) {
        return $paypalform;
    }

    function writeto($file, $msg) {
        $handle = @fopen( JPATH_BASE . DS . $file, "a");
        @fwrite($handle, date('Y-m-d H:i:s') . ': ' . $msg."\n");
        @fclose($handle);
    }

    function insert_currency()
    {
        global $database;
        $currencies = array(
            'RUB' => 'Russian Ruble (Russian Federation)'
        );
        return $currencies;
    }

    function deleteCurrency()
    {
        $database = JFactory::getDBO();

        $sql = "DELETE FROM #__digistore_currencies WHERE plugname='" . get_class($this) . "'";
        $database->setQuery($sql);
        $database->query();
    }

    function sandbox_support()
    {
        return 0;
    }

    function getFEData($items, $tax, $redirect, $profile, $plugin_conf, $configs)
    {
        global $Itemid;

        $mosConfig_live_site = JURI::base();
        $sid = $profile->_sid;

        $firstname = $profile->_user->name;
        $lastname = "";
        $email = $profile->_user->email;

        $uid = $profile->_user_id;

        $now = time();
        @session_start();
        $_SESSION['order_accepted'] = 0;

        $amount = $tax['taxed'];
        if (isset($_SESSION["new_cost"])) {
            $amount = $_SESSION["new_cost"];
        }

        $mnt_id = $plugin_conf->config->data['mnt_id'];
        $mnt_dataintegrity_code = $plugin_conf->config->data['mnt_dataintegrity_code'];
        $mnt_test_mode = $plugin_conf->config->data['mnt_test_mode'];
        $mnt_server = $plugin_conf->config->data['mnt_server'];

        $user = JFactory::getUser();
        $user_name = "";
        $user_email = "";

        if (isset($user->name) && trim($user->name) != "") {
            $user_name = trim($user->name);
        }

        if (isset($user->email) && trim($user->email) != "") {
            $user_email = trim($user->email);
        }

        if (isset($_SESSION["user_name"]) && trim($_SESSION["user_name"]) != "") {
            $user_name = @$_SESSION["user_name"];
        }

        if (isset($_SESSION["user_email"]) && trim($_SESSION["user_email"]) != "") {
            $user_email = @$_SESSION["user_email"];
        }

        $item_name = array();

        foreach ($items as $i => $item) {
            if ($i < 0) continue;
            $item_name[] = $item->name;
        }

        $mosConfig_live_site = JURI::base();

        $page_itemid = JFactory::getApplication()->input->get("Itemid", "0", "raw");

        if ($page_itemid != '0') {
            $Itemid = "&Itemid=" . $page_itemid;
        } else {
            $Itemid = NULL;
        }

        $notify_url = $mosConfig_live_site.'index.php?option=com_adagency&controller=adagencyCampaigns&task=notifyPayment&plugin=payanyway&no_html=1';

        $mnt_test_mode == '1' ? $mnt_test_mode = '1' : $mnt_test_mode = '0';

        $data = array(
            'MNT_ID' => $mnt_id,
            'MNT_AMOUNT' => number_format(sprintf("%.2f", $amount), 2, '.', ''),
            'MNT_TRANSACTION_ID' => $sid, //Unique payment ID to pass through to notify_url
            'MNT_CURRENCY_CODE' => 'RUB',
            'MNT_TEST_MODE' => $mnt_test_mode,
            'MNT_SUBSCRIBER_ID' => $uid
        );
        $data['MNT_SIGNATURE'] = md5($data['MNT_ID'].$data['MNT_TRANSACTION_ID'].$data['MNT_AMOUNT'].$data['MNT_CURRENCY_CODE'].
            $data['MNT_SUBSCRIBER_ID'].$data['MNT_TEST_MODE'].$mnt_dataintegrity_code);

        $pfHost = (strtolower(trim($mnt_server)) == "demo.moneta.ru") ? 'demo.moneta.ru' : 'www.payanyway.ru';
        ?>

        <div style="display: none;">
            <form action="https://<?php echo $pfHost; ?>/assistant.htm" method="post" id="payanyway-form">
<!--            <form action="http://localhost:8080/assistant.htm" method="post" id="payanyway-form">-->
                <?php
                foreach ($data as $name => $value) {
                    echo '<input name="' . $name . '" type="hidden" value="' . $value . '" />';
                }
                ?>

                <button type="submit" id="payanyway-submit" class="payanyway-button">Submit Payment</button>
            </form>
        </div>

        <script type="text/javascript">
            document.getElementById("payanyway-form").submit();
        </script>

        <?php
        @session_start();
        $_SESSION["myid"] = $uid;
        return "&nbsp";
    }

    function notify($plugin_conf, $cart, $configs, $plugin_handler)
    {
        global $Itemid;

        $plugin = $_GET["plugin"];

        if (trim($plugin) != "payanyway") {
            return;
        }

        $plugin_handler2 = $plugin_handler;
        $plugin_handler2->_id = $plugin_conf->id;
        $plugin_conf2 = $plugin_handler2->getPlugin();

        if (isset($_GET['MNT_ID']) && !empty($_GET['MNT_ID']))
        {
            $mnt_id = $_GET['MNT_ID'];
            $mnt_transaction_id = $_GET['MNT_TRANSACTION_ID'];
            $mnt_amount = $_GET['MNT_AMOUNT'];
            $mnt_currency_code = $_GET['MNT_CURRENCY_CODE'];
            $mnt_signature = $_GET['MNT_SIGNATURE'];
            $mnt_operation_id = $_GET['MNT_OPERATION_ID'];
            $mnt_subscriber_id = $_GET['MNT_SUBSCRIBER_ID'];
            $mnt_test_mode = $_GET['MNT_TEST_MODE'];
        } else
        {
            $mnt_id = $_POST['MNT_ID'];
            $mnt_transaction_id = $_POST['MNT_TRANSACTION_ID'];
            $mnt_amount = $_POST['MNT_AMOUNT'];
            $mnt_currency_code = $_POST['MNT_CURRENCY_CODE'];
            $mnt_signature = $_POST['MNT_SIGNATURE'];
            $mnt_operation_id = $_POST['MNT_OPERATION_ID'];
            $mnt_subscriber_id = $_POST['MNT_SUBSCRIBER_ID'];
            $mnt_test_mode = $_POST['MNT_TEST_MODE'];
        }
        $mnt_dataintegrity_code = $plugin_conf->config->data['mnt_dataintegrity_code'];
        $calculated_signature = md5($mnt_id.$mnt_transaction_id.$mnt_operation_id.$mnt_amount.$mnt_currency_code.$mnt_subscriber_id.$mnt_test_mode.$mnt_dataintegrity_code);
        if ($mnt_signature !== $calculated_signature)
        {
            ob_clean();
            echo "FAIL";
            die();
        } else {
            $db = JFactory::getDBO();

            $sql = "UPDATE #__ad_agency_order SET status = 'paid' WHERE oid = '$mnt_transaction_id'";
            $db->setQuery($sql);
            $db->query();

            $sql = "select * from #__ad_agency_order WHERE `oid` = '$mnt_transaction_id'";
            $db->setQuery($sql);
            $db->query();
            $order = $db->loadAssocList();
            (isset($order[0]) && isset($order[0]['notes'])) ? $order_notes = $order[0]['notes'] : $order_notes = '';

            $kassa_customer = null;
            if (isset($order[0]) && isset($order[0]['aid'])) {
                $sql = "select `email` from #__users WHERE `id` = (select `user_id` from #__ad_agency_advertis where `aid` = '{$order[0][aid]}')";
                $db->setQuery($sql);
                $db->query();
                $kassa_customer = $db->loadColumn()[0];
            }

//            $sql = "select `quantity`, `validity` from #__ad_agency_order_type where `tid`=".intval($order[0]['tid']);
//            $db->setQuery($sql);
//            $db->query();
//            $order_type = $db->loadAssocList();

            $inventoryPositions[] = array(
                'name' => trim(preg_replace("/&?[a-z0-9]+;/i", "", $order_notes)),
                'price' => $mnt_amount,
                'quantity' => 1,
                'vatTag' => self::paw_kassa_VATNOVAT,
            );
            $kassa_inventory = json_encode($inventoryPositions);
            self::monetaPayURLResponse($mnt_id, $mnt_transaction_id, $mnt_dataintegrity_code, true, false, true, true, $kassa_inventory, $kassa_customer);
        }
    }


    const paw_kassa_VAT0     = '1104';  // НДС 0%
    const paw_kassa_VAT10    = '1103';  // НДС 10%
    const paw_kassa_VAT18    = '1102';  // НДС 18%
    const paw_kassa_VATNOVAT = '1105';  // НДС не облагается
    const paw_kassa_VATWR10  = '1107';  // НДС с рассч. ставкой 10%
    const paw_kassa_VATWR18  = '1106';  // НДС с рассч. ставкой 18%


    private static function monetaPayURLResponse($mnt_id, $mnt_transaction_id, $mnt_data_integrity_code, $success = false,
                                                 $repeatRequest = false, $echo = true, $die = true, $kassa_inventory = null, $kassa_customer = null, $kassa_delivery = null)
    {
        if ($success === true)
            $resultCode = '200';
        elseif ($repeatRequest === true)
            $resultCode = '402';
        else
            $resultCode = '500';
        $mnt_signature = md5($resultCode.$mnt_id.$mnt_transaction_id.$mnt_data_integrity_code);
        $response = '<?xml version="1.0" encoding="UTF-8" ?>'."\n";
        $response .= "<MNT_RESPONSE>\n";
        $response .= "<MNT_ID>{$mnt_id}</MNT_ID>\n";
        $response .= "<MNT_TRANSACTION_ID>{$mnt_transaction_id}</MNT_TRANSACTION_ID>\n";
        $response .= "<MNT_RESULT_CODE>{$resultCode}</MNT_RESULT_CODE>\n";
        $response .= "<MNT_SIGNATURE>{$mnt_signature}</MNT_SIGNATURE>\n";
        if (!empty($kassa_inventory) || !empty($kassa_customer) || !empty($kassa_delivery))
        {
            $response .= "<MNT_ATTRIBUTES>\n";
            foreach (array('INVENTORY' => $kassa_inventory, 'CUSTOMER' => $kassa_customer, 'DELIVERY' => $kassa_delivery) as $k => $v)
                if (!empty($v))
                    $response .= "<ATTRIBUTE><KEY>{$k}</KEY><VALUE>{$v}</VALUE></ATTRIBUTE>\n";
            $response .= "</MNT_ATTRIBUTES>\n";
        }
        $response .= "</MNT_RESPONSE>\n";
        if ($echo === true)
        {
            ob_clean();
            header("Content-type: application/xml");
            echo $response;
        }
        else
            return $response;
        if ($die === true)
            die;
        return '';
    }


    function get_info()
    {
        $info = 'PayAnyWay';
        return $info;
    }
}